=== debian/changelog ===
qpid-proton (0.14.0-5.1ubuntu1) bionic; urgency=medium

  * -Wno-format does not disaable -Werror=format-security, as that one
    requires -Wformat.
  * Also fix up cmake install code path...

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Sun, 04 Feb 2018 22:16:50 +0000

qpid-proton (0.14.0-5.1build1) artful; urgency=medium

  * No change rebuild to drop Python 3.5 support.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Fri, 04 Aug 2017 18:57:22 +1200

qpid-proton (0.14.0-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Apply patch from James Cowgill to fix FTBFS on mips and mipsel.
    (Closes: #847976)

 -- Adrian Bunk <bunk@debian.org>  Sat, 01 Jul 2017 08:46:28 +0300

qpid-proton (0.14.0-5) unstable; urgency=medium

  * Team upload.
  * Change libqpid-proton-cpp8-dev depend to libqpid-proton-cpp8
    (Closes: #857411)

 -- Ondřej Nový <onovy@debian.org>  Fri, 10 Mar 2017 22:56:38 +0100

qpid-proton (0.14.0-4) unstable; urgency=medium

  * Team upload.
  * Removed C++ symbols file - it's really pain to maintain it

 -- Ondřej Nový <onovy@debian.org>  Tue, 22 Nov 2016 00:13:40 +0100

qpid-proton (0.14.0-3) unstable; urgency=medium

  * Team upload.

  [ Daniel Pocock ]
  * Replace legacy packages. (Closes: #843024)

  [ Ondřej Nový ]
  * Use OpenSSL 1.0, because OpenSSL 1.1 is not supported (Closes: #828521)
  * Bumped debhelper compat version to 10
  * d/control:
    - Use https protocol for Vcs-Git
    - Minor fixies in short descriptions
  * d/copyright: Fixed copyright for moved file
  * Added symbols file
  * Added simple autopkgtests for Python bindings

 -- Daniel Pocock <daniel@pocock.pro>  Thu, 03 Nov 2016 10:24:19 +0100

qpid-proton (0.14.0-2) unstable; urgency=medium

  * Tidy up lintian warnings.

 -- Daniel Pocock <daniel@pocock.pro>  Sat, 24 Sep 2016 18:50:36 +0200

qpid-proton (0.14.0-1) unstable; urgency=medium

  * New upstream release.

 -- Daniel Pocock <daniel@pocock.pro>  Thu, 22 Sep 2016 10:21:16 +0200
