=== debian/control ===
Source: qpid-proton
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Middleware Maintainers <pkg-middleware-maintainers@lists.alioth.debian.org>
Uploaders: Darryl L. Pierce <dpierce@redhat.com>,
           Daniel Pocock <daniel@pocock.pro>,
           Thomas Goirand <zigo@debian.org>,
Build-Depends: cmake,
               debhelper (>= 10),
               dh-python,
               doxygen,
               libssl1.0-dev,
               pkg-config,
               python-all,
               python-all-dev,
               python-epydoc,
               python3-all,
               python3-all-dev,
               swig,
               uuid-dev,
Standards-Version: 3.9.8
Homepage: http://qpid.apache.org/proton
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-middleware/qpid-proton.git
Vcs-Git: https://anonscm.debian.org/git/pkg-middleware/qpid-proton.git

Package: libqpid-proton8
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Pre-Depends: ${misc:Pre-Depends},
Description: C libraries for Qpid Proton
 Qpid Proton is a high-performance, lightweight messaging library. It can be
 used in the widest range of messaging applications, including brokers, client
 libraries, routers, bridges, proxies, and more. Proton makes it trivial to
 integrate with the AMQP 1.0 ecosystem from any platform, environment, or
 language.
 .
 This package provides the shared libraries for Qpid Proton.

Package: libqpid-proton-cpp8
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Pre-Depends: ${misc:Pre-Depends},
Description: C++ libraries for Qpid Proton
 Qpid Proton is a high-performance, lightweight messaging library. It can be
 used in the widest range of messaging applications, including brokers, client
 libraries, routers, bridges, proxies, and more. Proton makes it trivial to
 integrate with the AMQP 1.0 ecosystem from any platform, environment, or
 language.
 .
 This package provides the C++ shared libraries for Qpid Proton.

Package: libqpid-proton8-dev
Breaks: libqpid-proton2-dev
Replaces: libqpid-proton2-dev
Provides: libqpid-proton-dev
Architecture: any
Section: libdevel
Depends: libqpid-proton8 (= ${binary:Version}),
         ${misc:Depends},
Description: C Development libraries for writing messaging apps with Qpid Proton
 Qpid Proton is a high-performance, lightweight messaging library. It can be
 used in the widest range of messaging applications, including brokers, client
 libraries, routers, bridges, proxies, and more. Proton makes it trivial to
 integrate with the AMQP 1.0 ecosystem from any platform, environment, or
 language.
 .
 This package provides the C development libraries for Qpid Proton.

Package: libqpid-proton-cpp8-dev
Provides: libqpid-proton-cpp-dev
Architecture: any
Section: libdevel
Depends: libqpid-proton-cpp8 (= ${binary:Version}),
         libqpid-proton8-dev (= ${binary:Version}),
         ${misc:Depends},
Description: C++ Development libraries for writing messaging apps with Qpid Proton
 Qpid Proton is a high-performance, lightweight messaging library. It can be
 used in the widest range of messaging applications, including brokers, client
 libraries, routers, bridges, proxies, and more. Proton makes it trivial to
 integrate with the AMQP 1.0 ecosystem from any platform, environment, or
 language.
 .
 This package provides the C++ development libraries for Qpid Proton.

Package: libqpid-proton8-dev-examples
Architecture: all
Section: libdevel
Depends: libqpid-proton8-dev (>= ${binary:Version}),
         ${misc:Depends},
Breaks: libqpid-proton2-dev-examples
Replaces: libqpid-proton2-dev-examples
Provides: libqpid-proton-dev-examples
Description: Example applications for writign messaging apps with Qpid Proton
 Qpid Proton is a high-performance, lightweight messaging library. It can be
 used in the widest range of messaging applications, including brokers, client
 libraries, routers, bridges, proxies, and more. Proton makes it trivial to
 integrate with the AMQP 1.0 ecosystem from any platform, environment, or
 language.
 .
 This package provides C and C++ language examples for Qpid Proton.

Package: libqpid-proton8-dev-doc
Breaks: libqpid-proton2-dev-doc
Replaces: libqpid-proton2-dev-doc
Provides: libqpid-proton-dev-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}, libjs-jquery
Description: Developer documentation for Qpid Proton
 Qpid Proton is a high-performance, lightweight messaging library. It can be
 used in the widest range of messaging applications, including brokers, client
 libraries, routers, bridges, proxies, and more. Proton makes it trivial to
 integrate with the AMQP 1.0 ecosystem from any platform, environment, or
 language.
 .
 This package provides C developer documentation for Qpid Proton.

Package: libqpid-proton-cpp8-dev-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}, libjs-jquery
Description: C++ developer documentation for Qpid Proton
 Qpid Proton is a high-performance, lightweight messaging library. It can be
 used in the widest range of messaging applications, including brokers, client
 libraries, routers, bridges, proxies, and more. Proton makes it trivial to
 integrate with the AMQP 1.0 ecosystem from any platform, environment, or
 language.
 .
 This package provides C++ developer documentation for Qpid Proton.

Package: python-qpid-proton
Architecture: any
Section: python
Depends: libqpid-proton8,
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends},
Provides: ${python:Provides},
Description: language bindings for Qpid Proton messaging framework - Python 2.7
 Qpid Proton is a high-performance, lightweight messaging library. It can be
 used in the widest range of messaging applications, including brokers, client
 libraries, routers, bridges, proxies, and more. Proton makes it trivial to
 integrate with the AMQP 1.0 ecosystem from any platform, environment, or
 language.
 .
 This package provides Python 2.7 language bindings for Qpid Proton.

Package: python3-qpid-proton
Architecture: any
Section: python
Depends: libqpid-proton8,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
Provides: ${python3:Provides},
Description: language bindings for Qpid Proton messaging framework - Python 3.x
 Qpid Proton is a high-performance, lightweight messaging library. It can be
 used in the widest range of messaging applications, including brokers, client
 libraries, routers, bridges, proxies, and more. Proton makes it trivial to
 integrate with the AMQP 1.0 ecosystem from any platform, environment, or
 language.
 .
 This package provides Python 3.x language bindings for Qpid Proton.

Package: python-qpid-proton-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
Description: Documentation for the Python language bindings for Qpid Proton
 Qpid Proton is a high-performance, lightweight messaging library. It can be
 used in the widest range of messaging applications, including brokers, client
 libraries, routers, bridges, proxies, and more. Proton makes it trivial to
 integrate with the AMQP 1.0 ecosystem from any platform, environment, or
 language.
 .
 This package provides documentation for the Python language bindings for
 Qpid Proton.
